---
name: Bug report
about: Create a report to help us improve
title: ''
labels: bug, triage needed
assignees: ''

---

<!--
This repository tracks issues related to the implementation of the Swift
compiler, standard library, runtime, and tools that provide IDE support for
Swift (e.g. code completion). If the bug relates to the implementation of a
proprietary (closed-source) Apple framework such as UIKit, SwiftUI, Combine,
etc., please report it to https://feedbackassistant.apple.com instead.
-->

**Description**
<!-- Describe clearly and concisely what the bug is. -->

**Steps to reproduce**
<!--
Explain how to reproduce the problem (in steps if seen fit) and include either
an inline test case (preferred) or a project that reproduces it. Consider
reducing the sample to the smallest amount of code possible — a smaller test
case is easier to reason about and more appealing to contributors.
-->

**Expected behavior**
<!-- Describe what you expected to happen. -->

<!-- If deemed helpful, add screenshots that showcase the problem. -->
<!-- **Screenshots** -->

<!--
Include information about the Swift compiler version and, if applicable, the
Xcode version you are observing the problem in and the deployment target.
-->
**Environment**
- Swift compiler version info <!-- replace with the output of 'swiftc -version' -->
- Xcode version info <!-- replace with the output of 'xcodebuild -version' -->
- Deployment target: <!-- e.g. iOS 12.3 -->

<!-- Add any other context about the problem as appropriate. -->
<!-- **Additional context** -->
