// RUN: %target-swift-emit-ir %s -parse-stdlib -enable-experimental-feature Embedded -target arm64e-apple-none | %FileCheck %s

// TODO: investigate why windows is generating more metadata.
// XFAIL: OS=windows-msvc

struct Bool {}

protocol Player {
  func play()
  var canPlay: Bool { get }
}

struct Concrete : Player {
  func play() { }
  var canPlay: Bool { Bool() }
}

func start(p: some Player) {
  p.play()
}

public func main() {
  start(p: Concrete())
}

// CHECK-LABEL: define {{.*}}void @"$s4main8ConcreteVACycfC"()

// CHECK-LABEL: define {{.*}}void @"$s4main5start1pyx_tAA6PlayerRzlFAA8ConcreteV_Tg5"()

// CHECK-LABEL: define {{.*}}void @"$s4mainAAyyF"()
// CHECK-NEXT:  entry:
// CHECK-NEXT:    call swiftcc void @"$s4main8ConcreteVACycfC"()
// CHECK-NEXT:    call swiftcc void @"$s4main5start1pyx_tAA6PlayerRzlFAA8ConcreteV_Tg5"()
// CHECK-NEXT:    ret void
// CHECK-NEXT:  }
